/*
 * imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2010 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#include "stdafx.h"
#include "configure_dlg.h"
#include "flags.h"
#include "imgmirc.h"
#include "convthread.h"

#define MySetCheck(x, y) SendMessage(GetDlgItem (hwndDlg, (x)), BM_SETCHECK, (y), 0)
#define MyGetCheck(x)    SendMessage(GetDlgItem (hwndDlg, (x)), BM_GETCHECK,   0, 0)

DWORD DLG_IDS[NUM_FLAGS] = {IDC_IMG_LOAD,
                            IDC_IMG_VERBOSE,
                            IDC_IMG_QUITHOOK,
                            IDC_IMG_KBDHOOK,
                            IDC_IMG_KEEPALIVE,
                            IDC_IMG_PCREHL,
                            IDC_IMG_SMILE,
                            IDC_IMG_TRANSPARENT};

int __stdcall keepalive(HWND mWnd, HWND aWnd, char *data,
                        char *parms, BOOL show, BOOL nopause);

int __stdcall ConfigDlgProc(HWND hwndDlg,  // handle to dialog box
                            UINT uMsg,     // message
                            WPARAM wParam, // first message parameter
                            LPARAM lParam  // second message parameter
                           )
{
    static int i;
    switch (uMsg)
    {
        case WM_INITDIALOG:
            SetWindowText(hwndDlg, mircData);
            refresh = 0;
            for (i=0; i<NUM_FLAGS; i++)
                MySetCheck(DLG_IDS[i], flags[i].flag);
            EnableWindow(GetDlgItem(hwndDlg, IDC_IMG_TRANSPARENT), MyGetCheck(IDC_IMG_SMILE));
            return TRUE;
        case WM_DESTROY:
            SetEvent(hDlgDestroyed);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wParam))
            {
                case IDOK:
                    for (i=0; i<NUM_FLAGS; i++)
                        tmp_flags[i].flag = MyGetCheck(DLG_IDS[i]);
                    DestroyWindow(hwndDlg);
                    TerminateThread(hDlgThread, 0);
                    return TRUE;
                case IDCANCEL:
                    refresh = 0;
                    DestroyWindow(hwndDlg);
                    TerminateThread(hDlgThread, 0);
                    return TRUE;
            }
            if (HIWORD(wParam) == BN_CLICKED)
            {
                refresh = 1;
                if (LOWORD(wParam) == IDC_IMG_SMILE)
                    EnableWindow(GetDlgItem(hwndDlg, IDC_IMG_TRANSPARENT), MyGetCheck(IDC_IMG_SMILE));
            }
            break;
    }
    return FALSE;
}

DWORD WINAPI DlgThreadProc(void *p)
{
    HWND hwndCfgDlg = CreateDialog((HINSTANCE)hMod, MAKEINTRESOURCE(IDD_CONFIGURE), mircWnd, ConfigDlgProc);
    RECT rect;
    GetWindowRect(hwndCfgDlg, &rect);
    rect.left = (GetSystemMetrics(SM_CXFULLSCREEN) -  rect.right + rect.left) / 2;
    rect.top  = (GetSystemMetrics(SM_CYFULLSCREEN) - rect.bottom +  rect.top) / 2;
    SetWindowPos(hwndCfgDlg, NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
    ShowWindow(hwndCfgDlg, SW_SHOW);
    MSG msg;
    while (GetMessage(&msg, NULL, 0, 0))
        if (!IsDialogMessage(hwndCfgDlg, &msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    return 1;
}

int refresh = 0;
HANDLE hDlgThread;

HANDLE hDlgAllowed = NULL;
HANDLE hDlgDestroyed = NULL;
