/*
 * imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2010 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#include "stdafx.h"
#include "convthread.h"

HDDEDATA CALLBACK DdeCallback(UINT uType,         // transaction type
                              UINT uFmt,          // clipboard data format
                              HCONV hconv,        // handle to the conversation
                              HSZ hsz1,           // handle to a string
                              HSZ hsz2,           // handle to a string
                              HDDEDATA hdata,     // handle to a global memory object
                              ULONG_PTR dwData1,  // transaction-specific data
                              ULONG_PTR dwData2   // transaction-specific data
                              )
{
    return 0;
}

HDDEDATA conv_evaluate(HCONV hConv, char *data, BOOL keep)
{
    HDDEDATA hData = DdeClientTransaction(NULL,
                                          0,
                                          hConv,
                                          DdeCreateStringHandle(idInst, data, CP_WINANSI),
                                          CF_TEXT,
                                          XTYP_REQUEST,
                                          1000,
                                          NULL);
    if (keep)
        return hData;
    else
        DdeFreeDataHandle(hData);
    return NULL;
}

void conv_command(HCONV hConv, char *data)
{
    DdeClientTransaction((LPBYTE)data,
                         strlen(data) + 1,
                         hConv,
                         DdeCreateStringHandle(idInst, "dummyItem", CP_WINANSI),
                         CF_TEXT,
                         XTYP_POKE,
                         1000,
                         NULL);
}

void conv_echo(const char *str, int color)
{
    conv_echo(color, "%s", str);
}

void conv_echo(int color, const char *format_string, ...)
{
    static char pre_format_str[2048];
    static char cmd_str[2048];
    static va_list marker;
    va_start(marker, format_string);

    sprintf(pre_format_str, "//echo %d -a %s", color, format_string);
    vsprintf(cmd_str, pre_format_str, marker);
    conv_command(hCmdConv, cmd_str);
}

void conv_command(const char *format_string, ...)
{
    static char cmd_str[2048];
    static va_list marker;
    va_start(marker, format_string);
    vsprintf(cmd_str, format_string, marker);
    conv_command(hCmdConv, cmd_str);
}

void evaluate(char *data)
{
    HDDEDATA hData = conv_evaluate(hEvalConv, data, true);
    DdeGetData(hData, (LPBYTE)mircData, 900, 0);
    DdeFreeDataHandle(hData);
}
