/*
 * imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2010 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#include "stdafx.h"
#include "flags.h"
#include "convthread.h"

_flags tmp_flags[NUM_FLAGS];

_flags flags[NUM_FLAGS]=
{
    {"imgmirc_load",        0},
    {"imgmirc_verbose",     0},
    {"imgmirc_quithook",    0},
    {"imgmirc_kbdhook",     0},
    {"imgmirc_keepalive",   0},
    {"imgmirc_pcrehl",      0},
    {"imgmirc_smiles",      0},
    {"imgmirc_transparent", 0}
};

void load_all_flags()
{
    int all_flags = 0;
    evaluate("%imgmirc_config");
    if (sscanf(mircData, "%d", &all_flags) != 1)
        return;

    for (int i=0; i<NUM_FLAGS; i++)
        flags[i].flag = (all_flags & (1 << i)) >> i;
}

void save_all_flags(BOOL tmp_save)
{
    int all_flags = 0;

    if (tmp_save)
        for (int i=0; i<NUM_FLAGS; i++)
            all_flags += (tmp_flags[i].flag & 1 ) << i;
    else
        for (int i=0; i<NUM_FLAGS; i++)
            all_flags += (flags[i].flag & 1 ) << i;

    conv_command("/set %%imgmirc_config %d", all_flags);
}


