/*
 * imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2010 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#ifndef _HILIGHTS_
#define _HILIGHTS_

#include "pcre.h"

class _hl_item
{
public:

    static const unsigned char *ctables;

    char *ptrn;
    pcre *re;
    pcre_extra *pe;
    int *ovector;
    int np;

    _hl_item();
    _hl_item(LPCTSTR _ptrn, BOOL flag = true);
    ~_hl_item();

    int hl_exec(char * str, int len, int pos);
};

#define HL_STUB_LENGTH  6
#define HL_STUB_STRING   "      "
#define LHL_STUB_STRING L"      "


extern std::vector<_hl_item *> hl_list;
extern _hl_item *hl_privmsg;
extern char hl_mainstr[HL_STUB_LENGTH + 1];

#endif