/*
 * imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2010 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#include "stdafx.h"
#include "list_manage.h"
#include "convthread.h"
#include "highlights.h"
#include "replstorage.h"
#include "flags.h"

int __stdcall list_list(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
    if (!strncmp(data, "highlight", 9)) // highlight is listing
    {
        std::vector<_hl_item *>::iterator i;
        int l = strlen(data + 9); // if file name appears after 'highlight'
        if (l)
            conv_command("/write -c %s %d", data + 9, hl_list.size());
        else
            conv_echo("\x2list of precompiled patterns:\x2", 3);
        for (i=hl_list.begin(); i<hl_list.end(); i++)
        {
            if (!l)
                conv_echo(2, "%d:/%s/", (DWORD)(i - hl_list.begin()), (*i)->ptrn);
            else
                conv_command("/write %s %s", data + 9, (*i)->ptrn);
        }
        return 1;
    } else
        if (!strncmp(data, "replacement", 11)) // replacements is listing
        {
            conv_echo("\x2list of replacement items:\x2", 3);
            std::vector<_repl_item *>::iterator i;
            for (i=repl_list.begin(); i<repl_list.end(); i++)
                conv_echo(3, "%s %s (%d,%d,%d,%d)",
                          (*i)->hl->ptrn, (*i)->img->imgname,
                          (*i)->rect_image.left, (*i)->rect_image.top,
                          (*i)->rect_image.right, (*i)->rect_image.bottom);
            return 1;
        }
        conv_echo("imgmirc: invalid command.", 4);
        return 1;
}

int __stdcall list_add(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
    if (!strncmp(data, "highlight", 9)) // highlight is being added
    {
        try {
            _hl_item *hl_new = new _hl_item(data + 10);
            hl_list.push_back(hl_new);
        }
        catch (int)
        {
        }
        return 1;
    }
    conv_echo("invalid command.", 4);
    return 1;
}

int __stdcall list_del(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
{
    std::vector<_hl_item *>::iterator i;
    int s;
    if (!(s = hl_list.size())) return 1;
    if (!strncmp(data, "highlight", 9)) //highlight is deleting
    {
        int m;
        if (!sscanf(data + 9, "%d", &m))
            return 1;
        if (s - m <= 0) return 1;
        if (m < 0)
        {
            verb_conv_echo("imgmirc: Highlight list has been deleted.", 4);
            for (i=hl_list.begin(); i<hl_list.end(); i++)
                delete (*i);
            hl_list.clear();
            return 1;
        }
        i = hl_list.begin();
        std::advance(i, m);
        delete (*i);
        hl_list.erase(i);
        return 1;
    }
    conv_echo("imgmirc: invalid command.", 4);
    return 1;
}



