/*
 * imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2010 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#ifndef _MY_FUNCS_
#define _MY_FUNCS_

#include "convthread.h"
#include "winsock2.h"

enum _func_desc {
    func_recv, 
    func_textout_char, 
    func_textout_wchar, 
    func_drawtext_char, 
    func_drawtext_wchar,
    funcs_number
};

struct _func_tag
{
    DWORD *isd;
    DWORD old_func;
    DWORD new_func;
};

extern struct _func_tag func_tags[funcs_number];

typedef int  (__stdcall* funcptr_recv)(SOCKET, char FAR *, int, int);
typedef int  (__stdcall* funcptr_drawtext_char) (HDC, LPCTSTR, int, LPRECT, UINT);
typedef int  (__stdcall* funcptr_drawtext_wchar)(HDC, LPCWSTR, int, LPRECT, UINT);
typedef BOOL (__stdcall* funcptr_textout_char)  (HDC, int, int, UINT, const RECT*, LPCTSTR, UINT, const int*);
typedef BOOL (__stdcall* funcptr_textout_wchar) (HDC, int, int, UINT, const RECT*, LPCWSTR, UINT, const int*);

#define CALL_RECV (*(funcptr_recv)func_tags[func_recv].old_func)
#define CALL_TEXTOUT_A (*(funcptr_textout_char) func_tags[func_textout_char] .old_func)
#define CALL_TEXTOUT_W (*(funcptr_textout_wchar)func_tags[func_textout_wchar].old_func)
#define CALL_DRAWTEXT_A (*(funcptr_drawtext_char) func_tags[func_drawtext_char] .old_func)
#define CALL_DRAWTEXT_W (*(funcptr_drawtext_wchar)func_tags[func_drawtext_wchar].old_func)

// custom recv() implementation
int WINAPI my_recv(SOCKET s, char FAR *buf, int len, int flags);

// custom DrawText implementation
int WINAPI my_SimpleDrawTextA(HDC hDC,          // handle to DC
                              LPCTSTR lpchText, // text to draw
                              int nCount,       // text length
                              LPRECT lpRect,    // formatting dimensions
                              UINT uFormat      // text-drawing options
                             );
int WINAPI my_TransparentDrawTextA(HDC hDC,          // handle to DC
                                   LPCTSTR lpchText, // text to draw
                                   int nCount,       // text length
                                   LPRECT lpRect,    // formatting dimensions
                                   UINT uFormat      // text-drawing options
                                  );
int WINAPI my_SimpleDrawTextW(HDC hDC,          // handle to DC
                              LPCWSTR lpchText, // text to draw
                              int nCount,       // text length
                              LPRECT lpRect,    // formatting dimensions
                              UINT uFormat      // text-drawing options
                             );
int WINAPI my_TransparentDrawTextW(HDC hDC,          // handle to DC
                                   LPCWSTR lpchText, // text to draw
                                   int nCount,       // text length
                                   LPRECT lpRect,    // formatting dimensions
                                   UINT uFormat      // text-drawing options
                                  );

int intercept_function(LPCTSTR module_name,
                       LPCTSTR func_name,
                       _func_desc num,
                       DWORD new_func);
void do_intercept(void);
void return_functions();

#endif
