/*
 * imgmirc.dll is a plug-in for the mIRC application
 * Copyright (C) 2003-2010 Ivan Zvolsky
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library (lesser.txt)
 */
#ifndef _TEXTOUT_H_
#define _TEXTOUT_H_

class ITextOut {
public:
    virtual BOOL operator()(HDC hdc, int x , int y, UINT fuOptions, const RECT* lprc, void *lpString, UINT cbCount, const int* lpDx) = 0;
};

template<typename T>
class FTextOut : public ITextOut {
    typedef BOOL (__stdcall* func_ptr)(HDC, int, int, UINT, const RECT*, T, UINT, const int*);
    func_ptr _func;
public:
    FTextOut(DWORD func) {
        _func = (func_ptr)func;
    }
    virtual BOOL operator()(HDC hdc, int x , int y, UINT fuOptions, const RECT* lprc, void *lpString, UINT cbCount, const int* lpDx) {
        return (*_func)(hdc, x, y, fuOptions, lprc, (T)lpString, cbCount, lpDx);
    }
};

// custom ExtTextOut* implementation
BOOL WINAPI my_SimpleExtTextOutA(HDC, int, int, UINT, const RECT*, LPCTSTR, UINT, const int*);
BOOL WINAPI my_TranspExtTextOutA(HDC, int, int, UINT, const RECT*, LPCTSTR, UINT, const int*);

BOOL WINAPI my_SimpleExtTextOutW(HDC, int, int, UINT, const RECT*, LPCWSTR, UINT, const int*);
BOOL WINAPI my_TranspExtTextOutW(HDC, int, int, UINT, const RECT*, LPCWSTR, UINT, const int*);

#endif
